<template>
  <div>
    <el-dropdown trigger="click" @command="setLang">
      <span class="el-dropdown-link">
        <svg-icon :iconClass="getLocaleMeta(currentLang).icon" />
        {{getLocaleMeta(currentLang).name}}
        <i class="el-icon-arrow-down el-icon--right"></i>
      </span>
      <el-dropdown-menu slot="dropdown">
        <el-dropdown-item v-for="(locale, i) in locales" :key="i" :command="locale">
          <svg-icon :iconClass="getLocaleMeta(locale).icon" />
          {{ getLocaleMeta(locale).name }}
        </el-dropdown-item>
      </el-dropdown-menu>
    </el-dropdown>
  </div>
</template>

<script>
const Cookie = process.client ? require("js-cookie") : undefined;
export default {
  name: 'LangSwitcher',
  data() {
    return {
      currentLang: this.$store.getters['lang'],
      locales: this.$i18n.availableLocales.filter(i => i !== this.$i18n.locale)
    }
  },
  watch: {
    currentLang() {

      let oldLang = this.$store.getters['lang']

      this.locales = this.$i18n.availableLocales.filter(i => i !== this.currentLang)
      Cookie.set('lang', this.currentLang)
      this.$store.dispatch('setLang', this.currentLang)

      // if ((currentLang != 'es') && (this.$route.path != `/${currentLang}`) && (routePath.indexOf(`/${currentLang}/`) === -1)) {
      if (this.currentLang == 'es') {
        this.$router.push(this.$route.path.replace(`/${oldLang}/`, `/`))
      } else {
        this.$router.push(`/${this.currentLang}${this.$route.path}`)
      }
    },
  },
  methods: {
    setLang(locale) {
      this.currentLang = locale
    },
    getLocaleMeta(locale) {
      switch (locale) {
        case 'es':
          return {
            name: 'Español',
            icon: 'flag-spain'
          }
          break;
        case 'en':
          return {
            name: 'English',
            icon: 'flag-usa'
          }
          break;
        default:
          return ''
          break;
      }
    }
  }
}
</script>

<style>
.el-dropdown-link {
  cursor: pointer;
  color: #409eff;
}
.el-icon-arrow-down {
  font-size: 12px;
}
</style>